## igraph 0.10.2+ds

=== CMakeLists.txt ===
# Minimum CMake that we require is 3.18.
# Some of the recent features we use:
#  * --ignore-eol when comparing unit test results with expected outcomes (3.14)
#  * CROSSCOMPILING_EMULATOR can be a semicolon-separated list to pass arguments (3.15)
#  * SKIP_REGULAR_EXPRESSION to handle skipped tests properly (3.16)
#  * CheckLinkerFlag for HAVE_NEW_DTAGS test (3.18)
cmake_minimum_required(VERSION 3.18...3.22)

# Add etc/cmake to CMake's search path so we can put our private stuff there
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/etc/cmake)

# Set a default build type if none was specified
# This must precede the project() line, which would set the CMAKE_BUILD_TYPE
# to 'Debug' with single-config generators on Windows.
# Note that we must do this only if PROJECT_NAME is not set at this point. If
# it is set, it means that igraph is being used as a subproject of another
# project.
if(NOT PROJECT_NAME)
  include(BuildType)
endif()

# Prevent in-source builds
include(PreventInSourceBuilds)

# Make use of ccache if it is present on the host system -- unless explicitly
# asked to disable it
include(UseCCacheWhenInstalled)

# Figure out the version number from Git
include(version)

# Declare the project, its version number and language
project(
  igraph
  VERSION ${PACKAGE_VERSION_BASE}
  DESCRIPTION "A library for creating and manipulating graphs"
  HOMEPAGE_URL https://igraph.org
  LANGUAGES C CXX
)

# Include some compiler-related helpers and set global compiler options
include(compilers)

# Detect is certain attributes are supported by the compiler
include(attribute_support)

# Set default symbol visibility to hidden
set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)

# Set C and C++ standard version
set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED True)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED True)

# Expose the BUILD_SHARED_LIBS option in the ccmake UI
option(BUILD_SHARED_LIBS "Build shared libraries" OFF)

# Add switches to use sanitizers and debugging helpers if needed
include(debugging)
include(sanitizers)

# Add version information
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/include/igraph_version.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/include/igraph_version.h
)

# Create configuration options for optional features
include(features)

# Handle dependencies and dependency-related configuration options
include(dependencies)
find_dependencies()

# Run compile-time checks, generate config.h and igraph_threading.h
include(CheckSymbolExists)
include(CheckIncludeFiles)
include(CMakePushCheckState)

# First we check for some functions and symbols
cmake_push_check_state()
if(NEED_LINKING_AGAINST_LIBM)
  list(APPEND CMAKE_REQUIRED_LIBRARIES m)
endif()
check_symbol_exists(strcasecmp strings.h HAVE_STRCASECMP)
check_symbol_exists(strncasecmp strings.h HAVE_STRNCASECMP)
check_symbol_exists(_stricmp string.h HAVE__STRICMP)
check_symbol_exists(_strnicmp string.h HAVE__STRNICMP)
check_symbol_exists(strdup string.h HAVE_STRDUP)
check_symbol_exists(strndup string.h HAVE_STRNDUP)
check_include_files(xlocale.h HAVE_XLOCALE)
if(HAVE_XLOCALE)
  # On BSD, uselocale() is in xlocale.h instead of locale.h.
  # Some systems provide xlocale.h, but uselocale() is still in locale.h,
  # thus we try both.
  check_symbol_exists(uselocale "xlocale.h;locale.h" HAVE_USELOCALE)
else()
  check_symbol_exists(uselocale locale.h HAVE_USELOCALE)
endif()
check_symbol_exists(_configthreadlocale locale.h HAVE__CONFIGTHREADLOCALE)
cmake_pop_check_state()

# Check for 128-bit integer multiplication support, floating-point endianness
# and support for built-in overflow detection.
include(ieee754_endianness)
include(uint128_support)
include(safe_math_support)

if(NOT HAVE_USELOCALE AND NOT HAVE__CONFIGTHREADLOCALE)
  message(WARNING "igraph cannot set per-thread locale on this platform. igraph_enter_safelocale() and igraph_exit_safelocale() will not be safe to use in multithreaded programs.")
endif()

# Check for code coverage support
option(IGRAPH_ENABLE_CODE_COVERAGE "Enable code coverage calculation" OFF)
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME AND IGRAPH_ENABLE_CODE_COVERAGE)
  include(CodeCoverage)
  append_coverage_compiler_flags()
  setup_target_for_coverage_lcov(
    NAME coverage
    EXECUTABLE "${CMAKE_COMMAND}" "--build" "${PROJECT_BINARY_DIR}" "--target" "check"
    # Generated files are excluded; apparently the CodeCoverage script has some
    # problems with them. Yes, the exclusion is correct, it refers to a nonexistent
    # directory that somehow gets into the coverage results. /Applications and
    # /Library/Developer are for macOS -- they exclude files from the macOS SDK.
    EXCLUDE "io/*.l" "src/io/parsers/*" "io/parsers/*" "/Applications/Xcode*" "/Library/Developer/*" "examples/*" "interfaces/*" "tests/*" "vendor/pcg/*"
  )
endif()

# Generate configuration headers
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/src/config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/src/config.h
)
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/include/igraph_config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/include/igraph_config.h
)
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/include/igraph_threading.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/include/igraph_threading.h
)

# Enable unit tests. Behave nicely and do this only if we are not being
# included as a sub-project in another CMake project
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
  include(CTest)
  configure_file(
    ${PROJECT_SOURCE_DIR}/etc/cmake/CTestCustom.cmake.in
    ${PROJECT_BINARY_DIR}/CTestCustom.cmake
  )
endif()

# Traverse subdirectories. vendor/ should come first because code in
# src/CMakeLists.txt depends on targets in vendor/
add_subdirectory(vendor)
add_subdirectory(src)
add_subdirectory(interfaces)
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME AND BUILD_TESTING)
  add_subdirectory(tests)
endif()
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
  add_subdirectory(doc)
endif()

# Configure packaging -- only if igraph is the top-level project and not a
# subproject
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
  include(packaging)
endif()

# Show result of configuration
include(summary)

=== src/CMakeLists.txt ===

# Traverse subdirectories
add_subdirectory(centrality/prpack)
add_subdirectory(cliques/cliquer)
add_subdirectory(isomorphism/bliss)

# Generate lexers and parsers
set(PARSER_SOURCES)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/io/parsers)
foreach(FORMAT dl gml lgl ncol pajek)
  if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/io/parsers/${FORMAT}-parser.c)
    list(APPEND PARSER_SOURCES
      ${CMAKE_CURRENT_SOURCE_DIR}/io/parsers/${FORMAT}-lexer.c
      ${CMAKE_CURRENT_SOURCE_DIR}/io/parsers/${FORMAT}-parser.c
    )
  else()
    if (BISON_VERSION VERSION_GREATER_EQUAL 3)
      set(bison_no_deprecated -Wno-deprecated)
    endif()
    if (NOT FLEX_KEEP_LINE_NUMBERS)
      set(bison_hide_line_numbers --no-lines)
      set(flex_hide_line_numbers --noline)
    endif()
    bison_target(
      ${FORMAT}_parser io/${FORMAT}-parser.y ${CMAKE_CURRENT_BINARY_DIR}/io/parsers/${FORMAT}-parser.c
      COMPILE_FLAGS "${bison_hide_line_numbers} ${bison_no_deprecated}"
    )
    flex_target(
      ${FORMAT}_lexer io/${FORMAT}-lexer.l ${CMAKE_CURRENT_BINARY_DIR}/io/parsers/${FORMAT}-lexer.c
      COMPILE_FLAGS "${flex_hide_line_numbers}"
      DEFINES_FILE ${CMAKE_CURRENT_BINARY_DIR}/io/parsers/${FORMAT}-lexer.h
    )
    add_flex_bison_dependency(${FORMAT}_lexer ${FORMAT}_parser)
    list(APPEND PARSER_SOURCES ${BISON_${FORMAT}_parser_OUTPUTS} ${FLEX_${FORMAT}_lexer_OUTPUTS})
  endif()
endforeach()
add_custom_target(parsersources SOURCES ${PARSER_SOURCES})

# Declare the files needed to compile the igraph library
add_library(
  igraph
  core/array.c
  core/buckets.c
  core/cutheap.c
  core/dqueue.c
  core/error.c
  core/estack.c
  core/fixed_vectorlist.c
  core/grid.c
  core/heap.c
  core/indheap.c
  core/interruption.c
  core/marked_queue.c
  core/matrix.c
  core/matrix_list.c
  core/memory.c
  core/printing.c
  core/progress.c
  core/psumtree.c
  core/set.c
  core/sparsemat.c
  core/stack.c
  core/statusbar.c
  core/strvector.c
  core/trie.c
  core/vector.c
  core/vector_list.c
  core/vector_ptr.c

  math/complex.c
  math/safe_intop.c
  math/utils.c

  linalg/arpack.c
  linalg/blas.c
  linalg/eigen.c
  linalg/lapack.c

  random/random.c
  random/rng_glibc2.c
  random/rng_mt19937.c
  random/rng_pcg32.c
  random/rng_pcg64.c

  graph/adjlist.c
  graph/attributes.c
  graph/basic_query.c
  graph/caching.c
  graph/cattributes.c
  graph/graph_list.c
  graph/iterators.c
  graph/type_common.c
  graph/type_indexededgelist.c
  graph/visitors.c

  constructors/adjacency.c
  constructors/atlas.c
  constructors/basic_constructors.c
  constructors/circulant.c
  constructors/de_bruijn.c
  constructors/famous.c
  constructors/full.c
  constructors/generalized_petersen.c
  constructors/kautz.c
  constructors/lcf.c
  constructors/linegraph.c
  constructors/prufer.c
  constructors/regular.c

  games/barabasi.c
  games/callaway_traits.c
  games/citations.c
  games/correlated.c
  games/degree_sequence_vl/gengraph_degree_sequence.cpp
  games/degree_sequence_vl/gengraph_graph_molloy_hash.cpp
  games/degree_sequence_vl/gengraph_graph_molloy_optimized.cpp
  games/degree_sequence_vl/gengraph_mr-connected.cpp
  games/degree_sequence.c
  games/dotproduct.c
  games/erdos_renyi.c
  games/establishment.c
  games/forestfire.c
  games/grg.c
  games/growing_random.c
  games/islands.c
  games/k_regular.c
  games/preference.c
  games/recent_degree.c
  games/sbm.c
  games/static_fitness.c
  games/tree.c
  games/watts_strogatz.c

  centrality/betweenness.c
  centrality/centrality_other.c
  centrality/centralization.c
  centrality/closeness.c
  centrality/coreness.c
  centrality/eigenvector.c
  centrality/hub_authority.c
  centrality/pagerank.c
  centrality/truss.cpp
  centrality/prpack.cpp

  cliques/cliquer_wrapper.c
  cliques/cliques.c
  cliques/maximal_cliques.c
  cliques/glet.c

  community/community_misc.c
  community/edge_betweenness.c
  community/fast_modularity.c
  community/fluid.c
  community/infomap/infomap_FlowGraph.cc
  community/infomap/infomap_Greedy.cc
  community/infomap/infomap.cc
  community/label_propagation.c
  community/leading_eigenvector.c
  community/leiden.c
  community/louvain.c
  community/modularity.c
  community/optimal_modularity.c
  community/spinglass/clustertool.cpp
  community/spinglass/NetDataTypes.cpp
  community/spinglass/NetRoutines.cpp
  community/spinglass/pottsmodel_2.cpp
  community/walktrap/walktrap_communities.cpp
  community/walktrap/walktrap_graph.cpp
  community/walktrap/walktrap_heap.cpp
  community/walktrap/walktrap.cpp

  connectivity/cohesive_blocks.c
  connectivity/components.c
  connectivity/separators.c

  flow/flow.c
  flow/st-cuts.c

  hrg/hrg_types.cc
  hrg/hrg.cc

  io/dimacs.c
  io/dl.c
  io/dot.c
  io/edgelist.c
  io/graphml.c
  io/gml-tree.c
  io/gml.c
  io/graphdb.c
  io/leda.c
  io/lgl.c
  io/ncol.c
  io/pajek.c
  io/parse_utils.c
  ${PARSER_SOURCES}

  layout/circular.c
  layout/davidson_harel.c
  layout/drl/DensityGrid.cpp
  layout/drl/DensityGrid_3d.cpp
  layout/drl/drl_graph.cpp
  layout/drl/drl_graph_3d.cpp
  layout/drl/drl_layout.cpp
  layout/drl/drl_layout_3d.cpp
  layout/fruchterman_reingold.c
  layout/gem.c
  layout/graphopt.c
  layout/kamada_kawai.c
  layout/large_graph.c
  layout/layout_bipartite.c
  layout/layout_grid.c
  layout/layout_random.c
  layout/mds.c
  layout/merge_dla.c
  layout/merge_grid.c
  layout/reingold_tilford.c
  layout/sugiyama.c
  layout/umap.c

  operators/add_edge.c
  operators/complementer.c
  operators/compose.c
  operators/connect_neighborhood.c
  operators/contract.c
  operators/difference.c
  operators/disjoint_union.c
  operators/intersection.c
  operators/misc_internal.c
  operators/permute.c
  operators/reverse.c
  operators/rewire.c
  operators/rewire_edges.c
  operators/simplify.c
  operators/subgraph.c
  operators/union.c

  paths/all_shortest_paths.c
  paths/bellman_ford.c
  paths/dijkstra.c
  paths/distances.c
  paths/eulerian.c
  paths/floyd_warshall.c
  paths/histogram.c
  paths/johnson.c
  paths/random_walk.c
  paths/shortest_paths.c
  paths/simple_paths.c
  paths/sparsifier.c
  paths/unweighted.c
  paths/voronoi.c
  paths/widest_paths.c

  properties/basic_properties.c
  properties/constraint.c
  properties/convergence_degree.c
  properties/dag.c
  properties/degrees.c
  properties/ecc.c
  properties/girth.c
  properties/loops.c
  properties/multiplicity.c
  properties/neighborhood.c
  properties/perfect.c
  properties/spectral.c
  properties/trees.c
  properties/triangles.c

  isomorphism/bliss.cc
  isomorphism/isoclasses.c
  isomorphism/lad.c
  isomorphism/isomorphism_misc.c
  isomorphism/queries.c
  isomorphism/vf2.c

  misc/bipartite.c
  misc/chordality.c
  misc/cocitation.c
  misc/coloring.c
  misc/conversion.c
  misc/cycle_bases.c
  misc/degree_sequence.cpp
  misc/embedding.c
  misc/feedback_arc_set.c
  misc/graphicality.c
  misc/matching.c
  misc/microscopic_update.c
  misc/mixing.c
  misc/motifs.c
  misc/order_cycle.cpp
  misc/other.c
  misc/power_law_fit.c
  misc/scan.c
  misc/sir.c
  misc/spanning_trees.c

  internal/glpk_support.c
  internal/hacks.c
  internal/lsap.c
  internal/qsort_r.c
  internal/qsort.c
  internal/zeroin.c

  version.c

  # Vendored library sources. Yes, this is horrible.
  $<IF:$<OR:$<BOOL:${ARPACK_IS_VENDORED}>,$<BOOL:${BLAS_IS_VENDORED}>,$<BOOL:${LAPACK_IS_VENDORED}>>,$<TARGET_OBJECTS:f2c_vendored>,>
  $<IF:$<BOOL:${ARPACK_IS_VENDORED}>,$<TARGET_OBJECTS:arpack_vendored>,>
  $<IF:$<BOOL:${BLAS_IS_VENDORED}>,$<TARGET_OBJECTS:blas_vendored>,>
  $<IF:$<BOOL:${GLPK_IS_VENDORED}>,$<TARGET_OBJECTS:glpk_vendored>,>
  $<IF:$<BOOL:${GMP_IS_VENDORED}>,$<TARGET_OBJECTS:gmp_vendored>,>
  $<IF:$<BOOL:${LAPACK_IS_VENDORED}>,$<TARGET_OBJECTS:lapack_vendored>,>
  $<IF:$<BOOL:${PLFIT_IS_VENDORED}>,$<TARGET_OBJECTS:plfit_vendored>,>
)

# Required by Xcode new build system
add_dependencies(igraph parsersources)

# Set soname for the library
set_target_properties(igraph PROPERTIES VERSION "3.0.0")
set_target_properties(igraph PROPERTIES SOVERSION 3)

# Add extra compiler definitions if needed
target_compile_definitions(
  igraph
  PRIVATE
  IGRAPH_VERIFY_FINALLY_STACK=$<IF:$<BOOL:${IGRAPH_VERIFY_FINALLY_STACK}>,1,0>
)
# target_compile_options(
#   # -Wconversion could be useful?
#   igraph PRIVATE -Wshorten-64-to-32
# )

# Make sure that a macro named IGRAPH_FILE_BASENAME is provided in every
# compiler call so we can use these in debug messages without revealing the
# full path of the file on the machine where it was compiled
define_file_basename_for_sources(igraph)

# Add include path. Includes are in ../include but they get installed to
# <prefix>/include/igraph, hence the two options. We also have some private
# includes that are generated at compile time but are not part of the public
# interface.
target_include_directories(
  igraph
  PUBLIC
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
  $<INSTALL_INTERFACE:include/igraph>
  PRIVATE
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${PROJECT_SOURCE_DIR}/vendor

  # Vendored library include paths
  "$<$<BOOL:${GLPK_IS_VENDORED}>:$<TARGET_PROPERTY:glpk_vendored,INCLUDE_DIRECTORIES>>"
  "$<$<BOOL:${PLFIT_IS_VENDORED}>:$<TARGET_PROPERTY:plfit_vendored,INCLUDE_DIRECTORIES>>"

  # Include paths for dependencies
  "$<$<BOOL:${GLPK_INCLUDE_DIR}>:${GLPK_INCLUDE_DIR}>"
  "$<$<BOOL:${GMP_INCLUDE_DIR}>:${GMP_INCLUDE_DIR}>"
  "$<$<BOOL:${LIBXML2_INCLUDE_DIRS}>:${LIBXML2_INCLUDE_DIRS}>"
  "$<$<BOOL:${PLFIT_INCLUDE_DIRS}>:${PLFIT_INCLUDE_DIRS}>"
)

if(MATH_LIBRARY)
  target_link_libraries(igraph PUBLIC ${MATH_LIBRARY})
endif()

if(ARPACK_LIBRARIES)
  target_link_libraries(igraph PUBLIC ${ARPACK_LIBRARIES})
endif()

if(BLAS_LIBRARIES)
  target_link_libraries(igraph PUBLIC ${BLAS_LIBRARIES})
endif()

if(GLPK_LIBRARIES)
  target_link_libraries(igraph PUBLIC ${GLPK_LIBRARIES})
endif()

if(GMP_LIBRARIES)
  target_link_libraries(igraph PUBLIC ${GMP_LIBRARIES})
endif()

if(LAPACK_LIBRARIES)
  target_link_libraries(igraph PUBLIC ${LAPACK_LIBRARIES})
endif()

if(LIBXML2_LIBRARIES)
  target_link_libraries(igraph PUBLIC ${LIBXML2_LIBRARIES})
endif()

if(PLFIT_LIBRARIES)
  target_link_libraries(igraph PUBLIC ${PLFIT_LIBRARIES})
endif()

# Link igraph statically to some of the libraries from the subdirectories
target_link_libraries(
  igraph
  PRIVATE
  bliss cliquer cxsparse_vendored pcg prpack
)

if (NOT BUILD_SHARED_LIBS)
  target_compile_definitions(igraph PRIVATE IGRAPH_STATIC)
else()
  target_compile_definitions(igraph PRIVATE igraph_EXPORTS)
endif()

if(MSVC)
  # Add MSVC-specific include path for some headers that are missing on Windows
  target_include_directories(igraph PRIVATE ${PROJECT_SOURCE_DIR}/msvc/include)
endif()

# Turn on all warnings for GCC, clang and MSVC
use_all_warnings(igraph)

# GNUInstallDirs be included before generating the pkgconfig file, as it defines
# CMAKE_INSTALL_LIBDIR and CMAKE_INSTALL_INCLUDEDIR variables.
include(GNUInstallDirs)

# Generate pkgconfig file
include(pkgconfig_helpers)

include(GenerateExportHeader)
generate_export_header(igraph
  STATIC_DEFINE IGRAPH_STATIC
  EXPORT_FILE_NAME ${PROJECT_BINARY_DIR}/include/igraph_export.h
)

# Provide an igraph-config.cmake file in the installation directory so
# users can find the installed igraph library with FIND_PACKAGE(igraph)
# from their CMakeLists.txt files
include(CMakePackageConfigHelpers)
configure_package_config_file(
  ${PROJECT_SOURCE_DIR}/etc/cmake/igraph-config.cmake.in
  ${PROJECT_BINARY_DIR}/igraph-config.cmake
  # Install destination selected according to https://wiki.debian.org/CMake
  # and by looking at how eigen3 does it in Ubuntu
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/igraph
)
write_basic_package_version_file(
  ${PROJECT_BINARY_DIR}/igraph-config-version.cmake
  VERSION ${PACKAGE_VERSION_BASE}
  COMPATIBILITY SameMinorVersion
)

# Define how to install the library
install(
  TARGETS igraph bliss cliquer cxsparse_vendored pcg prpack
  EXPORT igraph_targets

=== tests/CMakeLists.txt ===
include(test_helpers)
include(benchmark_helpers)

add_library(test_utilities OBJECT unit/test_utilities.c)
target_link_libraries(test_utilities PRIVATE igraph)
use_all_warnings(test_utilities)

# Add a compatibility alias to the "test" target so it can also be invoked as
# "make check" - for people who have it in their muscle memories from autotools
add_custom_target(build_tests)
add_custom_target(
  check
  COMMAND ${CMAKE_CTEST_COMMAND} --progress --output-on-failure -C $<CONFIG>
  COMMENT "Executing unit tests..."
  USES_TERMINAL
)
add_dependencies(check build_tests)

# Add a custom target for benchmarks and another one for building them
add_custom_target(build_benchmarks)
add_custom_target(
  benchmark
  COMMAND true
  COMMENT "Running benchmarks..."
)
add_dependencies(benchmark build_benchmarks)

# Some newer gcc version have --enable-new-dtags on by default. This then leads
# to using RUNPATH instead of RPATH. Since RUNPATH is only considered after
# LD_LIBRARY_PATH, if another version of igraph is installed somewhere it will
# be linked to that library.
include(CheckLinkerFlag)
check_linker_flag(C "-Wl,--enable-new-dtags" HAVE_ENABLE_NEW_DTAGS)
if (HAVE_ENABLE_NEW_DTAGS AND BUILD_SHARED_LIBS)
  message(STATUS "Disabling new dtags for testing to use RPATH to ensure the correct library is found.")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--disable-new-dtags")
endif()

# tutorial examples and other snippets from the documentation
add_examples(
  FOLDER examples/tutorial NAMES
  tutorial1
  tutorial2
  tutorial3
)

# version.at
add_examples(
  FOLDER examples/simple NAMES
  igraph_version
)

# types.at
add_examples(
  FOLDER examples/simple NAMES
  dqueue
  igraph_sparsemat
  igraph_sparsemat3
  igraph_sparsemat4
  igraph_sparsemat6
  igraph_sparsemat7
  igraph_sparsemat8
  igraph_strvector
  igraph_vector_int_list_sort
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  heap
  igraph_array
  igraph_complex
  igraph_psumtree
  igraph_sparsemat5
  igraph_sparsemat9
  igraph_sparsemat_droptol
  igraph_sparsemat_fkeep
  igraph_sparsemat_getelements_sorted
  igraph_sparsemat_is_symmetric
  igraph_sparsemat_iterator_idx
  igraph_sparsemat_minmax
  igraph_sparsemat_nonzero_storage
  igraph_sparsemat_normalize
  igraph_sparsemat_view
  igraph_sparsemat_which_minmax
  igraph_strvector
  igraph_vector_floor
  igraph_vector_lex_cmp
  matrix
  matrix2
  matrix3
  matrix_complex
  stack
  strvector_set_len_remove_print
  vector
  vector2
  vector3
  vector4
  vector_list
  vector_ptr
  vector_ptr_sort_ind
  vector_qsort_ind
)

if ((NOT BUILD_SHARED_LIBS) OR (NOT BLAS_IS_VENDORED AND NOT ARPACK_IS_VENDORED))
  add_legacy_tests(
    FOLDER tests/unit NAMES
    igraph_sparsemat2 # Uses ARPACK and BLAS functions which are not publicly available when building with internal ARPACK/BLAS
  )
endif()

add_legacy_tests(
  FOLDER tests/unit NAMES
  2wheap
  cutheap
  d_indheap
  marked_queue
  set
  trie
)

# basic.at
add_examples(
  FOLDER examples/simple NAMES
  creation
  igraph_copy
  igraph_degree
  igraph_delete_edges
  igraph_delete_vertices
  igraph_get_eid
  igraph_get_eids
  igraph_is_directed
  igraph_neighbors
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  igraph_add_edges
  igraph_add_vertices
  igraph_degree
  igraph_delete_edges
  igraph_delete_vertices
  igraph_edges
  igraph_empty
  igraph_get_eid
  igraph_is_same_graph
  igraph_i_incident
  igraph_i_neighbors
  igraph_neighbors
)

# iterators.at
add_examples(
  FOLDER examples/simple NAMES
  igraph_es_pairs
  igraph_vs_nonadj
  igraph_vs_seq
  igraph_vs_vector
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  edge_selectors
  igraph_es_path
  igraph_es_all_between
  vertex_selectors
)

# structure_generators.at
add_examples(
  FOLDER examples/simple NAMES
  igraph_adjacency
  igraph_atlas
  igraph_barabasi_game
  igraph_barabasi_game2
  igraph_create
  igraph_degree_sequence_game
  igraph_erdos_renyi_game
  igraph_full
  igraph_grg_game
  igraph_kary_tree
  igraph_lcf
  igraph_realize_degree_sequence
  igraph_regular_tree
  igraph_ring
  igraph_small
  igraph_star
  igraph_symmetric_tree
  igraph_weighted_adjacency
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  constructor-failure
  erdos_renyi_game
  erdos_renyi_game_gnp
  full
  igraph_adjacency
  igraph_atlas
  igraph_barabasi_aging_game
  igraph_barabasi_game
  igraph_bipartite_game
  igraph_callaway_traits_game
  igraph_circulant
  igraph_cited_type_game
  igraph_citing_cited_type_game
  igraph_correlated_game
  igraph_correlated_pair_game
  igraph_create
  igraph_degree_sequence_game
  igraph_dot_product_game
  igraph_establishment_game
  igraph_extended_chordal_ring
  igraph_forest_fire_game
  igraph_from_prufer
  igraph_full_citation
  igraph_full_multipartite
  igraph_generalized_petersen
  igraph_grg_game
  igraph_growing_random_game
  igraph_hsbm_game
  igraph_hsbm_list_game
  igraph_k_regular_game
  igraph_lastcit_game
  igraph_linegraph
  igraph_kautz
  igraph_preference_game
  igraph_perfect
  igraph_realize_degree_sequence
  igraph_recent_degree_aging_game
  igraph_recent_degree_game
  igraph_sbm_game
  igraph_simple_interconnected_islands_game
  igraph_square_lattice
  igraph_static_power_law_game
  igraph_trussness
  igraph_turan
  igraph_wheel
  igraph_weighted_adjacency
  kary_tree
  symmetric_tree
  tree_game
  ring
  watts_strogatz_game
)

# structural_properties.at
add_examples(
  FOLDER examples/simple NAMES
  bellman_ford
  distances
  igraph_assortativity_degree
  igraph_assortativity_nominal
  igraph_average_path_length
  igraph_cocitation
  igraph_diameter
  igraph_eccentricity
  igraph_feedback_arc_set
  igraph_feedback_arc_set_ip
  igraph_get_all_shortest_paths_dijkstra
  igraph_get_shortest_paths
  igraph_get_shortest_paths_dijkstra
  igraph_girth
  igraph_has_multiple
  igraph_is_loop
  igraph_is_multiple
  igraph_list_triangles
  igraph_knn
  igraph_minimum_spanning_tree
  igraph_pagerank
  igraph_radius
  igraph_reciprocity
  igraph_similarity
  igraph_simplify
  igraph_topological_sorting
  igraph_transitivity
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  all_shortest_paths
  assortativity
  coreness
  efficiency
  global_transitivity
  hub_and_authority
  igraph_adjacent_triangles
  igraph_are_connected
  igraph_average_path_length
  igraph_average_path_length_dijkstra
  igraph_betweenness
  igraph_betweenness_subset
  igraph_closeness
  igraph_constraint
  igraph_convergence_degree
  igraph_count_multiple
  igraph_density
  igraph_diameter
  igraph_diameter_dijkstra
  igraph_diversity
  igraph_distances_floyd_warshall
  igraph_distances_johnson
  igraph_ecc
  igraph_eccentricity
  igraph_eccentricity_dijkstra
  igraph_edge_betweenness
  igraph_edge_betweenness_subset
  igraph_feedback_arc_set_undirected
  igraph_get_all_simple_paths
  igraph_get_all_shortest_paths_dijkstra
  igraph_get_k_shortest_paths
  igraph_get_shortest_paths2
  igraph_get_shortest_path_bellman_ford
  igraph_get_shortest_paths_bellman_ford
  igraph_get_shortest_paths_dijkstra
  igraph_graph_center
  igraph_has_mutual
  igraph_is_bipartite
  igraph_is_connected
  igraph_is_chordal
  igraph_is_mutual
  igraph_is_tree
  igraph_is_forest
  igraph_is_forest2
  igraph_is_acyclic
  igraph_list_triangles
  igraph_local_scan_k_ecount
  igraph_local_scan_k_ecount_them
  igraph_local_scan_subset_ecount
  igraph_local_transitivity
  igraph_neighborhood
  igraph_neighborhood_graphs
  igraph_neighborhood_size
  igraph_pagerank
  igraph_path_length_hist
  igraph_pseudo_diameter
  igraph_pseudo_diameter_dijkstra
  igraph_random_walk
  igraph_rewire # Uses internal igraph_i_rewire
  igraph_similarity
  igraph_transitive_closure_dag
  igraph_transitivity_avglocal_undirected
  igraph_transitivity_barrat
  igraph_unfold_tree
  igraph_voronoi
  igraph_widest_paths
  harmonic_centrality
  random_spanning_tree
  single_target_shortest_path
  topological_sorting
  igraph_spanner
)

add_legacy_tests(
  FOLDER tests/regression NAMES
  bug_1760
  bug_1814
  bug_1970
  bug_2150
)

# components.at
add_examples(
  FOLDER examples/simple NAMES
  igraph_biconnected_components
  igraph_decompose
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  igraph_bridges
  igraph_decompose_strong
  igraph_subcomponent
)

# layout.at
add_examples(
  FOLDER examples/simple NAMES
  igraph_layout_reingold_tilford
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  igraph_layout_drl
  igraph_layout_drl_3d
  igraph_layout_bipartite
  igraph_layout_fruchterman_reingold
  igraph_layout_fruchterman_reingold_3d
  igraph_layout_gem
  igraph_layout_graphopt
  igraph_layout_grid
  igraph_layout_kamada_kawai
  igraph_layout_lgl
  igraph_layout_mds
  igraph_layout_merge2
  igraph_layout_merge3
  igraph_layout_random_3d
  igraph_layout_reingold_tilford_circular
  igraph_layout_reingold_tilford_extended
  igraph_layout_star
  igraph_layout_sugiyama
  igraph_layout_umap
)
add_legacy_tests(
  FOLDER tests/regression NAMES
  igraph_layout_kamada_kawai_3d_bug_1462
  igraph_layout_reingold_tilford_bug_879
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  igraph_i_layout_sphere
  igraph_layout_davidson_harel # Uses igraph_i_layout_segments_intersect and igraph_i_layout_point_segment_dist2
  igraph_layout_merge # Uses igraph_i_layout_merge functions
  igraph_i_umap_fit_ab
)

# visitors.at
add_examples(
  FOLDER examples/simple NAMES
  igraph_bfs
  igraph_bfs_callback
  igraph_bfs_simple
)
add_legacy_tests(
  FOLDER tests/unit NAMES
  bfs
  bfs_simple
)

# topology.at
add_examples(
  FOLDER examples/simple NAMES
  igraph_isomorphic_vf2
  igraph_subisomorphic_lad
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  simplify_and_colorize
  bliss_automorphisms
  igraph_get_isomorphisms_vf2
  igraph_get_subisomorphisms_vf2
  igraph_isomorphic_vf2
  igraph_subisomorphic
  igraph_subisomorphic_lad
  igraph_isomorphic_bliss
  isomorphism_test
  isoclasses
  isoclasses2
  VF2-compat
)

# coloring.at
add_examples(
  FOLDER examples/simple NAMES
  igraph_coloring
)

# motifs.at
add_examples(
  FOLDER examples/simple NAMES
  igraph_motifs_randesu
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  igraph_dyad_census
  igraph_motifs_randesu
  igraph_motifs_randesu_estimate
  igraph_motifs_randesu_no
  triad_census
)

# foreign.at
add_examples(
  FOLDER examples/simple NAMES
  dot
  foreign
  gml
  graphml
  igraph_read_graph_dl
  igraph_read_graph_graphdb
  igraph_read_graph_lgl
  igraph_write_graph_lgl
  igraph_write_graph_pajek
  safelocale
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  foreign_empty
  igraph_read_graph_graphml
  gml
  igraph_write_graph_leda
  igraph_write_graph_dimacs_flow
  igraph_write_graph_dot
  lineendings
  ncol
  pajek
  pajek2
  pajek_bipartite
  pajek_bipartite2
  pajek_signed
)

# other.at
add_examples(
  FOLDER examples/simple NAMES
  igraph_power_law_fit
)
# igraph_power_law_fit() output is only deterministic when running with 1 thread
set_property(TEST example::igraph_power_law_fit APPEND PROPERTY ENVIRONMENT "OMP_NUM_THREADS=1")

add_legacy_tests(
  FOLDER tests/unit NAMES
  all_almost_e
  igraph_almost_equals
  igraph_convex_hull
  igraph_power_law_fit
  overflow
  prop_caching
  zapsmall
)
# igraph_power_law_fit() output is only deterministic when running with 1 thread
set_property(TEST test::igraph_power_law_fit APPEND PROPERTY ENVIRONMENT "OMP_NUM_THREADS=1")

# operators.at
add_examples(
  FOLDER examples/simple NAMES
  igraph_complementer
  igraph_compose
  igraph_difference
  igraph_disjoint_union
  igraph_intersection
  igraph_union
)

add_legacy_tests(
  FOLDER tests/unit NAMES
  igraph_contract_vertices
  igraph_connect_neighborhood
  igraph_induced_subgraph
  igraph_induced_subgraph_map
  igraph_intersection2
  igraph_permute_vertices
  igraph_reverse_edges
  igraph_rewire_directed_edges
)

# conversion.at
add_examples(
  FOLDER examples/simple NAMES
  adjlist
  igraph_get_laplacian
  igraph_get_laplacian_sparse
  igraph_to_undirected
)

add_legacy_tests(
  FOLDER tests/unit NAMES

=== vendor/CMakeLists.txt ===
add_subdirectory(cs)
add_subdirectory(f2c)
add_subdirectory(glpk)
add_subdirectory(lapack)
add_subdirectory(mini-gmp)
add_subdirectory(pcg)
add_subdirectory(plfit)

=== debian/changelog ===
igraph (0.10.2+ds-2) unstable; urgency=medium

  * Upload to unstable.
  * Debianization:
    - migrate from pkg-config to pkgconf, affect d/{,t/}/control;
    - libigraph-dev Depends now on libxml2-dev;
    - d/p//upstream-fixed-benchmarks-ig_distances-RNG-explicit_order.patch,
      import from upstream.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 20 Nov 2022 13:28:36 +0000

igraph (0.10.2+ds-1) experimental; urgency=medium

  * New upstream nano version.
  * Debianization:
    - d/watch, now use GitHub API to avoid breaking change from GitHub web UI
      (see https://lists.debian.org/debian-devel/2022/09/msg00229.html);
    - d/libigraph3.symbols, update.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 29 Oct 2022 14:23:46 +0000

igraph (0.10.1+ds-1) experimental; urgency=medium

  * New upstream minor (official release) version with breaking changes.
  * Debianization:
    - d/patches/*:
      - d/p/upstream-fix-*.patch, integrated;
    - d/libigraph3.symbols, update;
    - d/s/lintian-overrides, update.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 10 Sep 2022 17:14:25 +0000

igraph (0.10.0~rc2+ds-1) experimental; urgency=medium

  * New upstream minor (release candidate 2) version with breaking changes.
  * Debianization:
    - d/patches/*:
      - d/p/upstream-{fix-examples-nonewlineatendofoutfile,
          enhancement-examples-stdwar, source-lintian-spelling,
          fix-doc-cmake, missing-tools}.patch, integrated;
      - d/p/upstream-fix-{balling_manoeuver_issue,
         examples-simple-safelocale-typo}.patch, introduce.

 -- Jerome Benoit <calculus@rezozer.net>  Wed, 17 Aug 2022 18:26:52 +0000

igraph (0.10.0~rc1+ds-2) experimental; urgency=medium

  * Debianization:
    - d/patches/*:
      - d/p/debianization-external-plfit-neutralize-future_code.patch,
        obsoleted;
    - d/control:
      - Build-Depends field, cleanup.

 -- Jerome Benoit <calculus@rezozer.net>  Wed, 10 Aug 2022 13:17:49 +0000

igraph (0.10.0~rc1+ds-1) experimental; urgency=medium

  * New upstream minor (release candidate) version with breaking changes.
  * Debianization:
    - SONAME, bump from 2 to 3;
    - d/watch, adapt;
    - d/copyright:
      - Files-Excluded, keep the now tainted vendor/cs material;
      - copyright entries, adapt;
    - d/patches/*:
      - d/p/upstream-{fix-examples-nonewlineatendofoutfile,
          enhancement-examples-stdwar, source-lintian-spelling,
          fix-doc-cmake, missing-tools}.patch, introduce;
      - d/p/debianization-suitesparse-header_folder.patch, obsoleted;
      - d/p/debianization.patch, refresh;
      - d/p/debianization-external-plfit-neutralize-future_code, introduce;
    - tests/control:
      - simple check, operate now in a locales-all environment;
    - d/rules, refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 07 Aug 2022 14:52:48 +0000

igraph (0.9.10+ds-2) unstable; urgency=medium

  * Debianization:
    - d/watch, now use GitHub API to avoid breaking change from GitHub web UI
      (see https://lists.debian.org/debian-devel/2022/09/msg00229.html).

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 29 Oct 2022 13:15:30 +0000

igraph (0.9.10+ds-1) unstable; urgency=medium

  * New upstream nano version.
  * Debianization:
    - d/libigraph2.symbols, update;
    - d/control:
      - Standards-Version, dump to 4.6.1 (no change);
    - d/patches/*:
      - d/p/upstream-source-lintian-spelling.patch, imported
        from experimental.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 10 Sep 2022 11:37:09 +0000

=== debian/control ===
Source: igraph
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Jerome Benoit <calculus@rezozer.net>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake (>= 3.18),
               d-shlibs,
               bison,
               flex,
               libxml2-dev,
               libplfit-dev,
               libgmp-dev,
               libarpack2-dev,
               libblas-dev,
               liblapack-dev,
               libglpk-dev (>= 5.0),
               libf2c2-dev,
               liblzma-dev
Build-Depends-Indep: python3,
                     xmlto,
                     source-highlight,
                     fop,
                     fonts-font-awesome
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/igraph
Vcs-Git: https://salsa.debian.org/med-team/igraph.git
Homepage: https://igraph.org/c/
Rules-Requires-Root: no

Package: libigraph3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: library for creating and manipulating graphs
 igraph is a library for creating and manipulating graphs.
 It is intended to be as powerful (ie. fast) as possible to enable the
 analysis of large graphs.
 .
 This is the runtime library package.

Package: libigraph-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libigraph3 (= ${binary:Version}),
         libxml2-dev,
         ${devlibs:Depends},
         ${misc:Depends}
Suggests: libigraph-doc,
          pkgconf
Description: library for creating and manipulating graphs - development files
 igraph is a library for creating and manipulating graphs.
 It is intended to be as powerful (ie. fast) as possible to enable the
 analysis of large graphs.
 .
 This package contains the include files and static library for the igraph
 C library.

Package: libigraph-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: fonts-font-awesome,
         ${misc:Depends}
Suggests: libigraph-dev (= ${binary:Version}),
          libsuitesparse-dev,
          www-browser
Breaks: libigraph-examples (<< 0.9)
Replaces: libigraph-examples (<< 0.9)
Description: library for creating and manipulating graphs - reference manual
 igraph is a library for creating and manipulating graphs.
 It is intended to be as powerful (ie. fast) as possible to enable the
 analysis of large graphs.
 .
 This package provides the reference manual for the igraph C library;
 it also contains examples and tutorial material.

Package: libigraph-examples
Architecture: all
Multi-Arch: foreign
Section: oldlibs
Depends: libigraph-doc,
         ${misc:Depends}
Description: transitional package
 This is a transitional package. It can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

BUILDIR_STATIC=_BUILD_STATIC
BUILDIR_SHARED=_BUILD_SHARED

%:
	dh $@ --buildsystem=cmake --builddirectory=$(BUILDIR_SHARED)

#	--enable-debug

### disable TLS to fix warning with TLS and arpack
CONF_FLAGS= \
	-DIGRAPH_ENABLE_TLS=OFF \
	-DIGRAPH_USE_INTERNAL_BLAS=OFF \
	-DIGRAPH_USE_INTERNAL_LAPACK=OFF \
	-DIGRAPH_USE_INTERNAL_ARPACK=OFF \
	-DIGRAPH_USE_INTERNAL_GLPK=OFF \
	-DIGRAPH_USE_INTERNAL_GMP=OFF \
	-DIGRAPH_USE_INTERNAL_PLFIT=OFF \
	-DIGRAPH_GLPK_SUPPORT=ON \
	-DIGRAPH_GRAPHML_SUPPORT=ON \
	-DIGRAPH_OPENMP_SUPPORT=ON


### LTO does not really achieve anything for static libraries
override_dh_auto_configure:
	dh_auto_configure -B$(BUILDIR_SHARED) -- -DIGRAPH_ENABLE_LTO=ON  -DBUILD_SHARED_LIBS=ON  $(CONF_FLAGS)
	dh_auto_configure -B$(BUILDIR_STATIC) -- -DIGRAPH_ENABLE_LTO=OFF -DBUILD_SHARED_LIBS=OFF $(CONF_FLAGS)

override_dh_auto_build-indep:
	make -C $(BUILDIR_SHARED)/doc pdf
	make -C $(BUILDIR_SHARED)/doc html
	mv -v $(BUILDIR_SHARED)/doc/igraph-docs.pdf $(BUILDIR_SHARED)/doc/igraph.pdf
	make -C $(BUILDIR_SHARED)/doc clean

override_dh_auto_build-arch:
	dh_auto_build -a -B$(BUILDIR_STATIC)
	dh_auto_build -a -B$(BUILDIR_SHARED)

override_dh_auto_test-indep:

override_dh_auto_test-arch:
	dh_auto_test -a -B$(BUILDIR_STATIC)
	dh_auto_test -a -B$(BUILDIR_SHARED)

override_dh_auto_install-indep:

override_dh_auto_install-arch:
	dh_auto_install -a -B$(BUILDIR_STATIC)
	dh_auto_install -a -B$(BUILDIR_SHARED)

UPS_VERSION := $(subst ~rc,-rc.,$(firstword $(subst +, ,$(DEB_VERSION))))
DEB_DH_INSTALL_INDEP_DOCDIR := $(CURDIR)/debian/libigraph-doc/usr/share/doc/libigraph-dev
DEB_DH_INSTALL_INDEP_EXAMPLESDIR := $(DEB_DH_INSTALL_INDEP_DOCDIR)/examples
override_dh_install-indep:
	dh_install -i
	find $(DEB_DH_INSTALL_INDEP_EXAMPLESDIR)/simple -name '*.out' -exec sed -i 's|@VERSION@|$(UPS_VERSION)|' \{\} \;

override_dh_installchangelogs:
	dh_installchangelogs --keep CHANGELOG.md

override_dh_compress-indep:
	dh_compress -X/examples/

override_dh_missing:
	dh_missing -X.la

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDIR_SHARED) $(BUILDIR_STATIC)

## igraph 0.10.6+ds

=== debian/changelog ===
igraph (0.10.6+ds-1) unstable; urgency=medium

  * New upstream micro version.
  * Debianization:
    - d/patches/*:
      - d/p/upstream-fix-multiarch-file_conflict.patch, introduce;
    - d/libigraph-dev.install, fix multiarch issue (see previous patch);
    - d/libigraph3.symbols, update.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 15 Jul 2023 15:31:02 +0000

igraph (0.10.4+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 01 Jul 2023 21:46:28 +0000

igraph (0.10.4+ds-1) experimental; urgency=medium

  * New upstream micro version.
  * Debianization:
    - d/p/patches/*:
      - d/p/upstream-fixed-benchmarks-ig_distances-RNG-explicit_order.patch,
        obsoleted;
    - d/control:
      - Standards-Version, dump to 4.6.2 (no change);
    - d/libigraph3.symbols, update;
    - d/rules:
      - override_dh_auto_test-arch target, build test executables
        before calling dh_auto_test (see #924052);
    - various janitorial changes.

 -- Jerome Benoit <calculus@rezozer.net>  Tue, 28 Mar 2023 11:49:42 +0000

=== debian/control ===
--- 
+++ 
@@ -23,7 +23,7 @@
                      source-highlight,
                      fop,
                      fonts-font-awesome
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/igraph
 Vcs-Git: https://salsa.debian.org/med-team/igraph.git
 Homepage: https://igraph.org/c/

=== debian/rules ===
--- 
+++ 
@@ -44,8 +44,13 @@
 override_dh_auto_test-indep:
 
 override_dh_auto_test-arch:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	## see #924052 for further information
+	$(MAKE) -C $(BUILDIR_STATIC) -j$(NUMJOBS) build_tests
+	$(MAKE) -C $(BUILDIR_SHARED) -j$(NUMJOBS) build_tests
 	dh_auto_test -a -B$(BUILDIR_STATIC)
 	dh_auto_test -a -B$(BUILDIR_SHARED)
+endif
 
 override_dh_auto_install-indep:
